<?php

// QuickTicket 1.8 build:20080627

/*
 * CLASS cTopic
 *
 */

class cTopic
{

// -- Properties --

var $id = -1;
var $numid = -1;
var $section = -1;
var $type = 'T';   // A=News P=Post. Attention, alphabetic order can be used as display order (i.e. "News on top")
var $status = 'A'; // A=submitted Z=closed (News 0=closed). Attention user can sort according to the status index.
var $wisheddate;
var $firstpostid = -1;
var $lastpostid = -1;
var $firstpostuser = -1;
var $lastpostuser = -1;
var $firstpostname;
var $lastpostname;
var $firstpostdate;
var $lastpostdate;
var $x;
var $y;
var $z;
var $actorid = -1;
var $actorname = '';
var $notifiedid = -1;
var $notifiedname = '';
var $replies = 0;
var $views = 0;
var $youreply = '&nbsp;';
var $preview;
var $smile;
var $title;
var $sectiontitle = 'untitled';

// -- Constructor method (accept an array or a cTopic as parameter #1) --

function cTopic($oDB=null,$aTopic=null,$intUser=-1,$intPreviewsize=250)
{
  if ( isset($aTopic) )
  {    
    if ( is_int($aTopic) )
    {
      if ( $aTopic<0 ) die('cTopic: Wrong id');
      $oDB->Query('SELECT * FROM '.TABTOPIC.' WHERE id='.$aTopic);
      $row =  $oDB->Getrow();
      if ( $row===False ) die('No topic '.$aTopic);
      $this->MakeTopicFromArray($oDB,$row,$intPreviewsize);
      if ( $intUser>=0 )
      {
        // +1 when user is not the topic creator himself
        if ( $intUser != $this->firstpostuser )
        {
        $oDB->Query('UPDATE '.TABTOPIC.' SET views = views+1 WHERE id='.$this->id);
        }
      }
    }
    elseif ( is_array($aTopic) )
    {
      $this->MakeTopicFromArray($oDB,$aTopic,$intPreviewsize);
    }
    elseif ( strtolower(get_class($aTopic))=='ctopic' )
    {
      $this->id            = $aTopic->id;
      $this->numid         = $aTopic->numid;
      $this->section       = $aTopic->section;
      $this->type          = $aTopic->type;
      $this->status        = $aTopic->status;
      $this->wisheddate    = $aTopic->wisheddate;
      $this->firstpostid   = $aTopic->firstpostid;
      $this->lastpostid    = $aTopic->lastpostid; 
      $this->firstpostuser = $aTopic->firstpostuser; 
      $this->lastpostuser  = $aTopic->lastpostuser; 
      $this->firstpostname = $aTopic->firstpostname; 
      $this->lastpostname  = $aTopic->lastpostname; 
      $this->firstpostdate = $aTopic->firstpostdate; 
      $this->lastpostdate  = $aTopic->lastpostdate; 
      $this->x             = $aTopic->x; 
      $this->y             = $aTopic->y; 
      $this->z             = $aTopic->z; 
      $this->actorid       = $aTopic->actorid; 
      $this->actorname     = $aTopic->actorname; 
      $this->notifiedid    = $aTopic->notifiedid; 
      $this->notifiedname  = $aTopic->notifiedname; 
      $this->replies       = $aTopic->replies; 
      $this->views         = $aTopic->views; 
      $this->smile         = $aTopic->smile; 
      $this->title         = $aTopic->title; 
      $this->preview       = $aTopic->preview; 
    }
    else
    {
      die('Invalid constructor parameter #1 in the class cTopic');
    }
  }
  
}

// --------

function MakeTopicFromArray($oDB,$aTopic,$intPreviewsize=100)
{
  foreach ($aTopic as $strKey => $oValue) {
  switch ($strKey) {
    case 'textmsg':
      $this->preview = $oValue;
      if ( isset($oDB) ) {
      if ( isset($oDB->type) ) {
      if ( $oDB->type=='oci' ) {
        $this->preview = $aTopic['textmsg']->read(50000);
      }}}
      $this->preview = QTbbc($this->preview,'deepdrop',' ',$intPreviewsize,null,null,''); 
      break;
    case 'id':           $this->id           = intval($oValue); break;
    case 'numid':        $this->numid        = intval($oValue); break;
    case 'forum':        $this->section      = intval($oValue); break;
    case 'type':         $this->type         = $oValue; break;
    case 'status':       $this->status       = $oValue; break;
    case 'wisheddate':   $this->wisheddate   = $oValue; break;
    case 'firstpostid':  $this->firstpostid  = intval($oValue); break;
    case 'lastpostid':   $this->lastpostid   = intval($oValue); break;
    case 'firstpostuser':$this->firstpostuser= intval($oValue); break;
    case 'lastpostuser': $this->lastpostuser = intval($oValue); break;
    case 'firstpostname':$this->firstpostname= stripslashes($oValue); break;
    case 'lastpostname': $this->lastpostname = stripslashes($oValue); break;
    case 'firstpostdate':$this->firstpostdate= $oValue; break;
    case 'lastpostdate': $this->lastpostdate = $oValue; break;
    case 'actorid':      $this->actorid      = intval($oValue); if ($this->actorid==0) $this->actorid=null; break;
    case 'actorname':    $this->actorname    = stripslashes($oValue); break;
    case 'notifiedid':   $this->notifiedid   = intval($oValue); if ($this->notifiedid==0) $this->notifiedid=null; break;
    case 'notifiedname': $this->notifiedname = stripslashes($oValue); break;
    case 'replies':      $this->replies      = intval($oValue); break;
    case 'views':        $this->views        = intval($oValue); break;
    case 'icon':         $this->smile        = $oValue; break;
    case 'title':        $this->title        = stripslashes($oValue); break;
    case 'forumtitle':   $this->sectiontitle = stripslashes($oValue); break;
    case 'x': if ( is_numeric($oValue) ) $this->x = floatval($oValue); break; // must be FLOAT (or NULL)
    case 'y': if ( is_numeric($oValue) ) $this->y = floatval($oValue); break; // must be FLOAT (or NULL)
    case 'z': if ( is_numeric($oValue) ) $this->z = floatval($oValue); break; // must be FLOAT (or NULL)
  }}
}

// --------

function GetTopicTitle($oDB)
{
  $oDB->Query('SELECT title FROM '.TABPOST.' WHERE id='.$this->firstpostid);
  $row = $oDB->Getrow();
  $this->title = $row['title'];
  return $this->title;
}

// --------

function SetStatus($oDB,$L,$strStatus='A',$bCanNotify=true,$aPost=null)
{
  $oDB->Query('UPDATE '.TABTOPIC.' SET status="'.$strStatus.'" WHERE id='.$this->id);
  $this->status=$strStatus;
  
  // For NEWS or OTHER types, Z status is converted to 0 (to make it closed but visible)
  if ( $strStatus=='Z' )
  {
    $oDB->Query('UPDATE '.TABTOPIC.' SET status="0" WHERE id='.$this->id.' AND type="A"');
  }  
  
  // NOTIFY
  if ( $bCanNotify ) $this->NotifyStatus($oDB,$L,-1,$aPost);
}

// --------
// this change the type.

function SetType($oDB,$L,$intId=-1,$str='T')
{
  if ( $intId<0 ) die('Topic->SetType: Wrong id');
  $oDB->Query('UPDATE '.TABTOPIC.' SET type="'.$str.'" WHERE id='.$intId);
  if ( isset($this) ) $this->type=$str;
}

// --------

function SetActor($oDB,$L,$intActor=-1,$bCanNotify=TRUE,$aPost=null)
{
  $intOldactorid = $this->actorid;
  if ( $intActor<0 ) die('Topic->SetActor: Wrong actor id');
  
  // change actor
  $this->actorid = intval($intActor);
  $this->actorname = GetUserInfo($oDB,$this->actorid,'name');
  $oDB->Query('UPDATE '.TABTOPIC.' SET actorid='.$this->actorid.', actorname="'.$this->actorname.'" WHERE id='.$this->id);

  // posting a forward messsage
  $oPost = new cPost;
  $oPost->Pid = QTnextid($oDB,TABPOST);
  $oPost->Psection = $this->section;
  $oPost->Ptopic = $this->id;
  $oPost->Ptype = 'F';
  $oPost->Ptitle = $L['Topic_handled'].' '.strtolower($L['By']).' '.$this->actorname;
  $oPost->Ptext = sprintf($L['Topic_forwarded'],$this->actorname);
  $oPost->Puserid = $this->actorid;
  $oPost->Pusername = $this->actorname;
  $oPost->pissuedate = date('Y-m-d H:i:s');
  $oPost->Pmodifdate = '';
  $oPost->Pmodifuser = '';
  $oPost->InsertPost($oDB,true);
  $this->UpdateTopicStats($oDB,$this->id,9999,$oPost);
  
  if ( $bCanNotify ) $this->NotifyActor($oDB,$L,$intOldactorid);
}

// --------

function UpdateTopicStats($oDB,$id=-1,$intMax=100,$oLastPost=null)
{
  if ( $id<0 ) die('Topic->UpdateTopicStats: Wrong id');

  // query topics
  $strQ  = 'SELECT count(id) as countid FROM '.TABPOST.' WHERE type="R" AND topic='.$id;
  $oDB->Query($strQ);
  $row = $oDB->Getrow();
  $this->replies = intval($row['countid']);

  $strQ = '';
  if ( isset($oLastPost) )
  {
  $this->lastpostid = $oLastPost->Pid;
  $this->lastpostuser = $oLastPost->Puserid;
  $this->lastpostname = $oLastPost->Pusername;
  $this->lastpostdate = $oLastPost->Pdate;
  $strQ = ', lastpostid='.$this->lastpostid.', lastpostuser='.$this->lastpostuser.',lastpostname="'.$this->lastpostname.'", lastpostdate='.SQLdate($oDB,$this->lastpostdate);
  }

  // save stats
  $strQ  = 'UPDATE '.TABTOPIC.' SET replies='.$this->replies.$strQ.' WHERE id='.$id;
  $oDB->Query($strQ);

  // close topic if full
  if ( $this->replies>$intMax )
  {
  $oDB->Query('UPDATE '.TABTOPIC.' SET status="1" WHERE id='.$id);
  }
}

// --------

function InsertTopic($oDB,$L,$bUserStat=true,$bCanNotify=true,$oPost=null,$oSection=null)
{ 
  // insert
  $oDB->Query(
  'INSERT INTO '.TABTOPIC.' (id,forum,numid,type,status,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate,replies,actorid,actorname'.
  ( !empty($this->wisheddate) ? ',wisheddate' : '' ).
  ( $this->notifiedid>=0 ? ',notifiedid,notifiedname' : '' ).
  ( isset($this->x) ? ',x' : '' ).
  ( isset($this->y) ? ',y' : '' ).
  ( isset($this->z) ? ',z' : '' ).")
  VALUES (
  $this->id,$this->section,$this->numid,\"$this->type\",\"$this->status\",
  $this->firstpostid,$this->lastpostid,$this->firstpostuser,$this->lastpostuser,
  \"$this->firstpostname\",\"$this->lastpostname\",
  ".SQLdate($oDB,$this->firstpostdate).",".SQLdate($oDB,$this->lastpostdate).",
  $this->replies,$this->actorid,\"$this->actorname\"".
  ( !empty($this->wisheddate) ? ','.SQLdate($oDB,$this->wisheddate) : ''). 
  ( $this->notifiedid>=0 ? ",$this->notifiedid,\"$this->notifiedname\"" : ''). 
  ( isset($this->x) ? ','.$this->x : '').
  ( isset($this->y) ? ','.$this->y : '').
  ( isset($this->z) ? ','.$this->z : '').')'
  );

  // Status notification
  if ( $bCanNotify && $this->type=='T' ) $this->NotifyStatus($oDB,$L,-1,$oPost,$oSection);  

  Unset($_SESSION[QT]['sys_topics']);

  if ( $bUserStat )
  {
  $oDB->Query('SELECT count(*) as countid FROM '.TABPOST.' WHERE userid='.$this->firstpostuser);
  $row = $oDB->Getrow();
  $oDB->Query('UPDATE '.TABUSER.' SET lastdate='.SQLdate($oDB,$this->lastpostdate).', numpost='.$row['countid'].', ip="'.$oDB->ip.'" WHERE id='.$this->firstpostuser);
  $_SESSION[QT.'_usr_posts']++; 
  }
}

// --------

function NotifyActor($oDB,$L,$intOldactorid=-1,$oSection=null)
{ 
  if ( QTI_NOTIFY_NEWACTOR || QTI_NOTIFY_OLDACTOR ) {
  if ( $intOldactorid!=$this->actorid ) {
  if ( in_array($this->section,$_SESSION[QT]['sys_notifysections']) ) {

    // get section info (for the number format)
    if ( !isset($oSection) ) $oSection = new cSection($oDB,$this->section);
    // prepare mail
    $strTopic = ''; if ( $oSection->numfield!='N' ) $strTopic = sprintf($oSection->numfield,$this->numid).' ';
    $strMails = '';
    if ( QTI_NOTIFY_NEWACTOR && $this->actorid>=0 ) $strMails .= GetUserInfo($oDB,$this->actorid,'mail').',';
    if ( QTI_NOTIFY_OLDACTOR && $intOldactorid>=0 ) $strMails .= GetUserInfo($oDB,$intOldactorid,'mail');
    $strMessage = sprintf("{$L['Topic']} %s ",$strTopic);
    $strMessage .= sprintf($L['Topic_forwarded'],$this->actorname);
    $strSubject = "{$_SESSION[QT]['site_name']}: {$L['Notification']} $strTopic";   
    // send mail
    include('bin/qt_lib_smtp.php');
    if ( !empty($strMails) ) QTmail($strMails,QTunquote($strSubject),QTunquote($strMessage),QTI_HTML_CHAR);
  }}}
}

function NotifyStatus($oDB,$L,$intOldactorid=-1,$aPost=null,$oSection=null)
{

  if ( in_array($this->section,$_SESSION[QT]['sys_notifysections']) ) {
  if ( !empty($_SESSION['qtiTstatus'][$this->status]['mailto']) ) {

    // get section info (for the number format)
    if ( !isset($oSection) ) $oSection = new cSection($oDB,$this->section);

    // read message (and get it if not yet defined)
    if ( !isset($this->title) && isset($aPost) )
    {
      $oPost = new cPost($oDB,$aPost);
      $this->title = $oPost->Ptitle;
      $this->preview = QTbbc($oPost->Ptext,'deepdrop',' ',100,null,null,'');
    }
    if ( empty($this->title) ) $this->title = '';
    if ( empty($this->preview) ) $this->preview = '';     
    $strTopic = ($oSection->numfield!='N' ? sprintf($oSection->numfield,$this->numid).' ' : '').$this->title."\r\n".$this->preview;

    $strFile = $_SESSION[QT]['language'].'/mail_status.inc';

    // notify list

    $lstMails = explode(',',$_SESSION['qtiTstatus'][$this->status]['mailto']);
    $lstMails = array_unique($lstMails);

    // notify mails
    $arrMails = array();
    foreach ($lstMails as $intUser)
    {
      switch ($intUser)
      {
      case 'MF': $arrMails[] = GetUserInfo($oDB,"$this->section",'mail',$oSection); break;
      case 'MA': if ( $this->actorid>=0 ) $arrMails[] = GetUserInfo($oDB,$this->actorid,'mail'); break;
      case 'U':
        $arrMails[] = GetUserInfo($oDB,intval($this->firstpostuser),'mail');
        if ( $this->notifiedid>=0 ) $arrMails[] = GetUserInfo($oDB,intval($this->notifiedid),'mail');
        break;
      case 'A': $arrMails = $arrMails + GetUserInfo($oDB,'A','mail'); break;
      case 'S': $arrMails = $arrMails + GetUserInfo($oDB,'S','mail'); break;
      default:  if ( $intUser>=0 ) $arrMails[] = GetUserInfo($oDB,intval($intUser),'mail'); break;
      }
    }
    $arrMails = array_unique($arrMails);
    $strMails = implode(', ',$arrMails);

    // message containing 2 parameters (the status, the topic preview)
    $strMessage = "{$L['Status']}: %s \r\n%s";
    if ( file_exists($strFile) ) include($strFile);
    $strMessage = sprintf($strMessage,$_SESSION['qtiTstatus'][$this->status]['name'],$strTopic);

    $strSubject = $_SESSION[QT]['site_name'].': '.$L['Notification'].' '.$this->title;

    // send mail
    include('bin/qt_lib_smtp.php');
    QTmail($strMails,QTunquote($strSubject),QTunquote($strMessage),QTI_HTML_CHAR);

    // show send mails
    $strMails = '<br/><br/>'.$L['Notification'].': '.$strMails;

  }}
}

// --------

}

?>